/**
 * jslinq - Another LINQ provider for Javascript

 * @version    : 1.0.22
 * @author     : maurobussini
 * @license    : MIT
 * @repository : https://github.com/maurobussini/jslinq.git
 * @built      : 2020-2-26
 */
!function(t,e){"function"==typeof define&&define.amd?define([],e):"object"==typeof exports?module.exports=e():t.jslinq=e()}(this,function(){function t(t){if(!t)throw new Error("Provided data is invalid");if(!(t instanceof Array))throw new Error("Provided data is not a valid array");return this.items=t,this.select=r,this.where=i,this.groupBy=n,this.join=s,this.intersect=L,this.distinct=h,this.orderBy=o,this.orderByDescending=u,this.selectMany=f,this.singleOrDefault=l,this.firstOrDefault=a,this.lastOrDefault=m,this.any=c,this.all=v,this.toList=w,this.count=g,this.skip=p,this.take=d,this.max=E,this.min=y,this.remove=b,this.subtract=x,this.sum=k,this.average=B,this}function e(t,i){if(t===i)return!0;if(t==i)return!0;if(typeof t!=typeof i)return!1;if("object"!=typeof t)return t==i;for(var r in t){var n=t[r],s=i[r];if(!("object"==typeof n?e(n,s):n==s))return!1}return!0}function i(e){if(!e)throw new Error("Expression is invalid");for(var i=[],r=0;r<this.items.length;r++){e(this.items[r])&&i.push(this.items[r])}return new t(i)}function r(e){if(!e)throw new Error("Expression is invalid");for(var i=[],r=0;r<this.items.length;r++){var n=e(this.items[r]);i.push(n)}return new t(i)}function n(i){if(!i)throw new Error("Expression is invalid");for(var r=[],n=0;n<this.items.length;n++){for(var s=i(this.items[n]),h=null,o=0;o<r.length;o++)if(e(r[o].key,s)){h=r[o];break}h||(h={key:s,count:0,elements:[]},r.push(h)),h.count++,h.elements.push(this.items[n])}return new t(r)}function s(e){if(!e)return new t(this.items);for(var i=[],r=0;r<this.items.length;r++)i.push(this.items[r]);for(var n=0;n<e.length;n++)i.push(e[n]);return new t(i)}function h(){for(var i=[],r=0;r<this.items.length;r++){for(var n=!1,s=0;s<i.length;s++)if(e(i[s],this.items[r])){n=!0;break}n||i.push(this.items[r])}return new t(i)}function o(e){if(!e)throw new Error("Expression is invalid");for(var i=function(t,i){var r=e(t),n=e(i);return r<n?-1:r>n?1:0},r=[],n=0;n<this.items.length;n++)r.push(this.items[n]);return new t(r.sort(i))}function u(e){if(!e)throw new Error("Expression is invalid");return new t(t(this.items).orderBy(e).toList().reverse())}function f(e){if(!e)throw new Error("Expression is invalid");for(var i=[],r=0;r<this.items.length;r++){var n=e(this.items[r]);if(!n){i.push(n);break}for(var s=0;s<n.length;s++)i.push(n[s])}return new t(i)}function l(e){var i;if(i=e?t(this.items).where(e).toList():this.items,0===i.length)return null;if(1==i.length)return i[0];throw new Error("Sequence contains "+i.length+" matching elements")}function a(e){var i;return i=e?t(this.items).where(e).toList():this.items,0===i.length?null:i[0]}function m(e){var i;return i=e?t(this.items).where(e).toList():this.items,0===i.length?null:i[i.length-1]}function c(e){var i;return i=e?t(this.items).where(e).toList():this.items,i.length>0}function v(e){var i;return i=e?t(this.items).where(e).toList():this.items,i.length==this.items.length}function w(){return this.items}function g(){return this.items.length}function p(e){if(e<0)throw new Error("Value must be greater or equals zero");for(var i=[],r=0;r<this.items.length;r++)i.push(this.items[r]);return new t(i.slice(e))}function d(e){if(e<0)throw new Error("Value must be greater or equals zero");for(var i=[],r=0;r<this.items.length;r++)i.push(this.items[r]);return new t(i.slice(0,e))}function E(e){var i;return i=e?t(this.items).select(e).toList():this.items,0===i.length?null:(i=t(i).orderBy(function(t){return t}).toList(),i[i.length-1])}function y(e){var i;return i=e?t(this.items).select(e).toList():this.items,0===i.length?null:(i=t(i).orderBy(function(t){return t}).toList(),i[0])}function L(i,r){if(!i)return new t([]);for(var n=[],s=0;s<this.items.length;s++)for(var h=this.items[s],o=0;o<i.length;o++){var u=i[o],f=!1;if(r){var l=r(h),a=r(u);f=e(l,a)}else f=e(h,u);f&&n.push(h)}return new t(n)}function b(i){if(!i)return new t(this.items);for(var r=[],n=0;n<this.items.length;n++)e(this.items[n],i)||r.push(this.items[n]);return new t(r)}function x(i,r){if(!i)return new t([]);for(var n=[],s=0;s<this.items.length;s++){for(var h=this.items[s],o=!1,u=0;u<i.length;u++)if(!o){var f=i[u],l=!1;if(r){var a=r(h),m=r(f);l=e(a,m)}else l=e(h,f);l&&(o=!0)}o||n.push(h)}return new t(n)}function k(e){if(!e)throw new Error("Expression is invalid");for(var i=t(this.items).select(e).toList(),r=0,n=0;n<i.length;n++){var s=i[n];if("number"!=typeof s)throw Error("Value '"+s+"' is not a number");r+=s}return r}function B(e){var i;if(i=e?t(this.items).select(e).toList():this.items,0===i.length)return null;for(var r=0,n=0;n<i.length;n++){if(isNaN(i[n]))throw new Error("Element '"+i[n]+"' (index:"+n+") is not a number");r=i[n]+r}return r/i.length}function j(e){return new t(e)}return j});